
local zeroResults = WHO_NUM_RESULTS:format(0)
local resultsString = "^"..WHO_NUM_RESULTS.."$"
local nameWaiting = nil

local function WhoTip_SetItemRef(link)
	if link:sub(1, 6) == "player" then
		local name = link:match("^player:(.-):")
		if name and IsShiftKeyDown() then
			nameWaiting = name
		end
	end
end

local function ShowTip()
	local numWhos = GetNumWhoResults()
	if numWhos == 0 then return end

	local name, guild, level, race, class, zone, filename
	for i = 1, numWhos do
		name, guild, level, race, class, zone, filename = GetWhoInfo(i)
		if name == nameWaiting then break end
	end

	if WhoTipDB.atMouse then
		GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
	else
		GameTooltip_SetDefaultAnchor(GameTooltip, UIParent)
	end

	local levelColor = GetQuestDifficultyColor(level)
	levelColor = levelColor and ("%02x%02x%02x"):format(levelColor.r * 255, levelColor.g * 255, levelColor.b * 255) or "c0c0c0"
	local classColor = RAID_CLASS_COLORS[filename]
	classColor = classColor and ("%02x%02x%02x"):format(classColor.r * 255, classColor.g * 255, classColor.b * 255) or "808080"

	GameTooltip:AddLine(("|cff%s%s|r"):format(classColor, name))
	GameTooltip:AddLine(("|cff%s%d|r |cffffffff%s|r |cff%s%s|r"):format(levelColor, level, race, classColor, class))
	if guild ~= "" then
		GameTooltip:AddLine(("<%s>"):format(guild), .1, 1, .1)
	end
	GameTooltip:AddLine(zone, 1, .82, 0)
	GameTooltip:Show()
end

local f = CreateFrame("Frame")
f:SetScript("OnEvent", function(self, event, arg1)
	if event == "CHAT_MSG_SYSTEM" then
		if nameWaiting then
			if arg1 == zeroResults then
				nameWaiting = nil
			elseif arg1:match(resultsString) then
				ShowTip()
				nameWaiting = nil
			end
		end
	elseif event == "ADDON_LOADED" and arg1 == "WhoTip" then
		self:UnregisterEvent("ADDON_LOADED")
		WhoTipDB = WhoTipDB or { atMouse = false }
		self:RegisterEvent("CHAT_MSG_SYSTEM")
		hooksecurefunc("SetItemRef", WhoTip_SetItemRef)
	end
end)
f:RegisterEvent("ADDON_LOADED")

SLASH_WHOTIP1 = "/whotip"
SlashCmdList["WHOTIP"] = function(input)
	WhoTipDB.atMouse = not WhoTipDB.atMouse
	DEFAULT_CHAT_FRAME:AddMessage(("|cff33ff99WhoTip|r: Tooltip anchor: %s"):format(WhoTipDB.atMouse and "Cursor" or "Default"))
end
